(*  Title:      ISM/DYSProtocols.thy
    Id:         $Id: DYSProtocols.thy,v 1.8 2004/06/08 18:07:08 dvo Exp $
    Author:     David von Oheimb
    License:    (C) 2002 Siemens AG; any non-commercial use is granted

*)

header {* Security protocol analysis according to the Dolev-Yao model *}

theory DYSProtocols
imports ISM_package 
       "$ISABELLE_HOME/src/HOL/Auth/Public" (* by Larry Paulson *)

begin
(*<*)
hide const used
(*>*)

types nonce = nat

(*<*)
declare split_paired_Ex [simp del]
declare fun_upd_apply [simp del] fun_upd_same [simp] fun_upd_other [simp]

lemma analz_Key_Un [simp]: "analz (Key ` A \<union> Key ` B) = Key ` A \<union> Key ` B"
by (simp add: image_Un [symmetric])

declare analz_subset_parts [THEN subsetD, dest]
declare Fake_parts_insert [THEN subsetD, dest]
(*declare image_eq_UN [simp]*)  (*accelerates proofs involving nested images*)
(*>*)

end
